﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;

namespace WpfSumBoundUnbound
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private InvoiceCollection GetFakeData()
        {
            Invoice invoice = null;
            InvoiceCollection lRes = new InvoiceCollection();

            invoice = new Invoice();
            invoice.Descr = "Invoice-001";
            invoice.TotalAmount = 12;
            lRes.Add(invoice);

            invoice = new Invoice();
            invoice.Descr = "Invoice-002";
            invoice.TotalAmount = 30;
            lRes.Add(invoice);

            invoice = new Invoice();
            invoice.Descr = "Invoice-003";
            invoice.TotalAmount = 10;
            lRes.Add(invoice);

            return lRes;
        }

        public static FieldLayout GetOrCreateFieldLayout(XamDataGrid xamDataGrid)
        {
            if (xamDataGrid.DefaultFieldLayout == null)
            {
                if (xamDataGrid.FieldLayouts.Count == 0)
                    xamDataGrid.FieldLayouts.Add(new FieldLayout());
                else
                    xamDataGrid.DefaultFieldLayout = xamDataGrid.FieldLayouts[0];
            }

            return xamDataGrid.DefaultFieldLayout;
        }

        public static Field AddFieldToDataGrid(XamDataGrid xamDataGrid, string fieldName, Type editorType, bool isUnbound)
        {
            Field field = null;

            if (isUnbound)
                field = new UnboundField();
            else
                field = new Field();

            FieldLayout fieldLayout = null;
            fieldLayout = GetOrCreateFieldLayout(xamDataGrid);

            fieldLayout.Settings.AutoGenerateFields = false;

            field.Name = fieldName;

            if (isUnbound)
                field.Label = fieldName + " Unbound";
            else
                field.Label = fieldName + " Bound";

            field.Settings.EditorType = editorType;

            if (isUnbound)
            {
                (field as UnboundField).BindingPath = new PropertyPath(fieldName);
                (field as UnboundField).BindingMode = BindingMode.TwoWay;
            }

            fieldLayout.Fields.Add(field);

            return field;
        }

        private void btnGo_Click(object sender, RoutedEventArgs e)
        {
            xamDataGrid.FieldSettings.AllowSummaries = true;
            xamDataGrid.FieldSettings.SummaryUIType = SummaryUIType.MultiSelectForNumericsOnly;
            xamDataGrid.FieldSettings.SummaryDisplayArea = SummaryDisplayAreas.BottomFixed;

            AddFieldToDataGrid(xamDataGrid, "Descr", typeof(XamTextEditor), false);
            AddFieldToDataGrid(xamDataGrid, "TotalAmount", typeof(XamNumericEditor), false);
            AddFieldToDataGrid(xamDataGrid, "TotalAmount", typeof(XamNumericEditor), true);

            xamDataGrid.DataSource = GetFakeData();

            btnGo.IsEnabled = false;
        }

    }
}
